import { FieldFeedbackType } from './FieldFeedbackType';
import { FieldFeedbackValidation } from './FieldFeedbackValidation';
import { HTMLInput, TextInput } from './InputElement';
export declare class Field {
    readonly name: string;
    readonly validations: FieldFeedbackValidation[];
    element?: HTMLInput | TextInput;
    constructor(name: string);
    addOrReplaceValidation(validation: FieldFeedbackValidation): void;
    clearValidations(): void;
    hasFeedbacksOfType(type: FieldFeedbackType, fieldFeedbacksKey?: string): boolean;
    hasErrors(fieldFeedbacksKey?: string): boolean;
    hasWarnings(fieldFeedbacksKey?: string): boolean;
    hasInfos(fieldFeedbacksKey?: string): boolean;
    hasFeedbacks(fieldFeedbacksKey?: string): boolean;
    isValid(): boolean;
}
