import { EventEmitter } from './EventEmitter';
import { Field } from './Field';
export declare enum FieldEvent {
    Added = "FIELD_ADDED",
    Removed = "FIELD_REMOVED"
}
export declare class FieldsStore extends EventEmitter<[Field | string], void> {
    readonly fields: Field[];
    getField(fieldName: string): Field | undefined;
    addField(fieldName: string): void;
    removeField(fieldName: string): void;
    isValid(): boolean;
    hasFeedbacks(): boolean;
}
