"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.withFieldDidResetEventEmitter = exports.FieldDidResetEvent = void 0;
const EventEmitter_1 = require("./EventEmitter");
exports.FieldDidResetEvent = 'FIELD_DID_RESET_EVENT';
function withFieldDidResetEventEmitter(Base) {
    return class ResetFieldEvenEmitter extends Base {
        constructor() {
            super(...arguments);
            this.fieldDidResetEventEmitter = new EventEmitter_1.EventEmitter();
        }
        emitFieldDidResetEvent(field) {
            return this.fieldDidResetEventEmitter.emitSync(exports.FieldDidResetEvent, field);
        }
        addFieldDidResetEventListener(listener) {
            this.fieldDidResetEventEmitter.addListener(exports.FieldDidResetEvent, listener);
        }
        removeFieldDidResetEventListener(listener) {
            this.fieldDidResetEventEmitter.removeListener(exports.FieldDidResetEvent, listener);
        }
    };
}
exports.withFieldDidResetEventEmitter = withFieldDidResetEventEmitter;
