"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.withFieldWillValidateEventEmitter = exports.FieldWillValidateEvent = void 0;
const EventEmitter_1 = require("./EventEmitter");
exports.FieldWillValidateEvent = 'FIELD_WILL_VALIDATE_EVENT';
function withFieldWillValidateEventEmitter(Base) {
    return class FieldWillValidateEventEmitter extends Base {
        constructor() {
            super(...arguments);
            this.fieldWillValidateEventEmitter = new EventEmitter_1.EventEmitter();
        }
        emitFieldWillValidateEvent(fieldName) {
            return this.fieldWillValidateEventEmitter.emitSync(exports.FieldWillValidateEvent, fieldName);
        }
        addFieldWillValidateEventListener(listener) {
            this.fieldWillValidateEventEmitter.addListener(exports.FieldWillValidateEvent, listener);
        }
        removeFieldWillValidateEventListener(listener) {
            this.fieldWillValidateEventEmitter.removeListener(exports.FieldWillValidateEvent, listener);
        }
    };
}
exports.withFieldWillValidateEventEmitter = withFieldWillValidateEventEmitter;
