import { EventEmitter } from './EventEmitter';
export const FieldDidValidateEvent = 'FIELD_DID_VALIDATE_EVENT';
export function withFieldDidValidateEventEmitter(Base) {
    return class FieldDidValidateEventEmitter extends Base {
        constructor() {
            super(...arguments);
            this.fieldDidValidateEventEmitter = new EventEmitter();
        }
        emitFieldDidValidateEvent(field) {
            return this.fieldDidValidateEventEmitter.emitSync(FieldDidValidateEvent, field);
        }
        addFieldDidValidateEventListener(listener) {
            this.fieldDidValidateEventEmitter.addListener(FieldDidValidateEvent, listener);
        }
        removeFieldDidValidateEventListener(listener) {
            this.fieldDidValidateEventEmitter.removeListener(FieldDidValidateEvent, listener);
        }
    };
}
