import { EventEmitter } from './EventEmitter';
export const FieldWillValidateEvent = 'FIELD_WILL_VALIDATE_EVENT';
export function withFieldWillValidateEventEmitter(Base) {
    return class FieldWillValidateEventEmitter extends Base {
        constructor() {
            super(...arguments);
            this.fieldWillValidateEventEmitter = new EventEmitter();
        }
        emitFieldWillValidateEvent(fieldName) {
            return this.fieldWillValidateEventEmitter.emitSync(FieldWillValidateEvent, fieldName);
        }
        addFieldWillValidateEventListener(listener) {
            this.fieldWillValidateEventEmitter.addListener(FieldWillValidateEvent, listener);
        }
        removeFieldWillValidateEventListener(listener) {
            this.fieldWillValidateEventEmitter.removeListener(FieldWillValidateEvent, listener);
        }
    };
}
