import { Constructor } from './Constructor';
import { EventEmitter } from './EventEmitter';
import { InputElement } from './InputElement';
export declare const ValidateFieldEvent = "VALIDATE_FIELD_EVENT";
export declare function withValidateFieldEventEmitter<ListenerReturnType, TBase extends Constructor<{}>>(Base: TBase): {
    new (...args: any[]): {
        validateFieldEventEmitter: EventEmitter<[InputElement], ListenerReturnType>;
        emitValidateFieldEvent(input: InputElement): Promise<ListenerReturnType[]>;
        addValidateFieldEventListener(listener: (input: InputElement) => ListenerReturnType | Promise<ListenerReturnType>): void;
        removeValidateFieldEventListener(listener: (input: InputElement) => ListenerReturnType | Promise<ListenerReturnType>): void;
    };
} & TBase;
