import { EventEmitter } from './EventEmitter';
export const ValidateFieldEvent = 'VALIDATE_FIELD_EVENT';
export function withValidateFieldEventEmitter(Base) {
    return class ValidateFieldEventEmitter extends Base {
        constructor() {
            super(...arguments);
            this.validateFieldEventEmitter = new EventEmitter();
        }
        emitValidateFieldEvent(input) {
            return this.validateFieldEventEmitter.emitAsync(ValidateFieldEvent, input);
        }
        addValidateFieldEventListener(listener) {
            this.validateFieldEventEmitter.addListener(ValidateFieldEvent, listener);
        }
        removeValidateFieldEventListener(listener) {
            this.validateFieldEventEmitter.removeListener(ValidateFieldEvent, listener);
        }
    };
}
